Loading...
Searching...
No Matches
qa_utils.h File Reference
`#include <stdbool.h>`
`#include <volk/volk.h>`
`#include <cstdlib>`
`#include <map>`
`#include <string>`
`#include <vector>`
`#include "volk/volk_complex.h"`

Go to the source code of this file.

## Data Structures

struct | volk_type_t
class | volk_test_time_t
class | volk_test_results_t
class | volk_test_params_t
class | volk_test_case_t

## Macros

#define | VOLK_PROFILE(func, test_params, results)
#define | VOLK_PUPPET_PROFILE(func, puppet_master_func, test_params, results)

## Typedefs

typedef void(* | volk_fn_1arg) (void *, unsigned int, const char *)
typedef void(* | volk_fn_2arg) (void *, void *, unsigned int, const char *)
typedef void(* | volk_fn_3arg) (void *, void *, void *, unsigned int, const char *)
typedef void(* | volk_fn_4arg) (void *, void *, void *, void *, unsigned int, const char *)
typedef void(* | volk_fn_1arg_s32f) (void *, float, unsigned int, const char *)
typedef void(* | volk_fn_2arg_s32f) (void *, void *, float, unsigned int, const char *)
typedef void(* | volk_fn_3arg_s32f) (void *, void *, void *, float, unsigned int, const char *)
typedef void(* | volk_fn_1arg_s32fc) (void *, lv_32fc_t *, unsigned int, const char *)
typedef void(* | volk_fn_2arg_s32fc) (void *, void *, lv_32fc_t *, unsigned int, const char *)
typedef void(* | volk_fn_3arg_s32fc) (void *, void *, void *, lv_32fc_t *, unsigned int, const char *)

## Functions

double | volk_test_get_warmup_ms ()
void | volk_test_set_warmup_ms (double ms)
void | volk_test_reset_warmup ()
volk_type_t | volk_type_from_string (std::string)
float | uniform (void)
void | random_floats (float *buf, unsigned n)
void | load_random_data (void *data, volk_type_t type, unsigned int n, const std::vector< float > &float_edge_cases=std::vector< float >(), const std::vector< lv_32fc_t > &complex_edge_cases=std::vector< lv_32fc_t >())
bool | run_volk_tests (volk_func_desc_t, void(*)(), std::string, volk_test_params_t, std::vector< volk_test_results_t > *results=NULL, std::string puppet_master_name="NULL")
bool | run_volk_tests (volk_func_desc_t, void(*)(), std::string, float, lv_32fc_t, unsigned int, unsigned int, std::vector< volk_test_results_t > *results=NULL, std::string puppet_master_name="NULL", bool absolute_mode=false, bool benchmark_mode=false, const std::vector< float > &float_edge_cases=std::vector< float >(), const std::vector< lv_32fc_t > &complex_edge_cases=std::vector< lv_32fc_t >())

## Macro Definition Documentation

## VOLK_PROFILE

#define VOLK_PROFILE | ( |  | func,
|  |  | test_params,
|  |  | results )

Value:
run_volk_tests(func##_get_func_desc(), \
(void (*)())func##_manual, \
std::string(#func), \
test_params, \
results, \
"NULL")

## VOLK_PUPPET_PROFILE

#define VOLK_PUPPET_PROFILE | ( |  | func,
|  |  | puppet_master_func,
|  |  | test_params,
|  |  | results )

Value:
run_volk_tests(func##_get_func_desc(), \
(void (*)())func##_manual, \
std::string(#func), \
test_params, \
results, \
std::string(#puppet_master_func))

## Typedef Documentation

## volk_fn_1arg

typedef void(* volk_fn_1arg) (void *, unsigned int, const char *)

## volk_fn_1arg_s32f

typedef void(* volk_fn_1arg_s32f) (void *, float, unsigned int, const char *)

## volk_fn_1arg_s32fc

typedef void(* volk_fn_1arg_s32fc) (void *, lv_32fc_t *, unsigned int, const char *)

## volk_fn_2arg

typedef void(* volk_fn_2arg) (void *, void *, unsigned int, const char *)

## volk_fn_2arg_s32f

typedef void(* volk_fn_2arg_s32f) (void *, void *, float, unsigned int, const char *)

## volk_fn_2arg_s32fc

typedef void(* volk_fn_2arg_s32fc) (void *, void *, lv_32fc_t *, unsigned int, const char *)

## volk_fn_3arg

typedef void(* volk_fn_3arg) (void *, void *, void *, unsigned int, const char *)

## volk_fn_3arg_s32f

typedef void(* volk_fn_3arg_s32f) (void *, void *, void *, float, unsigned int, const char *)

## volk_fn_3arg_s32fc

typedef void(* volk_fn_3arg_s32fc) (void *, void *, void *, lv_32fc_t *, unsigned int, const char *)

## volk_fn_4arg

typedef void(* volk_fn_4arg) (void *, void *, void *, void *, unsigned int, const char *)

## Function Documentation

## load_random_data()

void load_random_data | ( | void * | data,
|  | volk_type_t | type,
|  | unsigned int | n,
|  | const std::vector< float > & | float_edge_cases = std::vector< float >(),
|  | const std::vector< lv_32fc_t > & | complex_edge_cases = std::vector< lv_32fc_t >() )

## random_floats()

void random_floats | ( | float * | buf,
|  | unsigned | n )

## run_volk_tests() [1/2]

bool run_volk_tests | ( | volk_func_desc_t | desc,
|  | void(* | manual_func )(),
|  | std::string | name,
|  | float | tol,
|  | lv_32fc_t | scalar,
|  | unsigned int | vlen,
|  | unsigned int | iter,
|  | std::vector< volk_test_results_t > * | results = NULL,
|  | std::string | puppet_master_name = "NULL",
|  | bool | absolute_mode = false,
|  | bool | benchmark_mode = false,
|  | const std::vector< float > & | float_edge_cases = std::vector< float >(),
|  | const std::vector< lv_32fc_t > & | complex_edge_cases = std::vector< lv_32fc_t >() )

## run_volk_tests() [2/2]

bool run_volk_tests | ( | volk_func_desc_t | desc,
|  | void(* | manual_func )(),
|  | std::string | name,
|  | volk_test_params_t | test_params,
|  | std::vector< volk_test_results_t > * | results = NULL,
|  | std::string | puppet_master_name = "NULL" )

## uniform()

float uniform | ( | void |  | ) |

## volk_test_get_warmup_ms()

double volk_test_get_warmup_ms | ( |  | ) |

## volk_test_reset_warmup()

void volk_test_reset_warmup | ( |  | ) |

## volk_test_set_warmup_ms()

void volk_test_set_warmup_ms | ( | double | ms | ) |

## volk_type_from_string()

volk_type_t volk_type_from_string | ( | std::string | name | ) |